<?php

namespace Drupal\aws_cloud\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * IpPermission field validation.
 *
 * @Constraint(
 *   id = "ip_permission_data",
 *   label = @Translation("IP Permission", context = "Validation"),
 * )
 */
class IpPermissionDataConstraint extends Constraint {

  /**
   * A message: "The To Port is not numeric".
   *
   * @var string
   */
  public $toPortNotNumeric = "The To Port is not numeric.";

  /**
   * A message: "The From Port is not numeric".
   *
   * @var string
   */
  public $fromPortNotNumeric = "The From Port is not numeric.";

  /**
   * A message: "CIDR IP is empty".
   *
   * @var string
   */
  public $ip4IsEmpty = "CIDR IP is empty.";

  /**
   * A message: "CIDR IP is not valid".
   *
   * @var string
   */
  public $ip4Value = "CIDR IP is not valid. Single IP addresses must be in x.x.x.x/32 notation.";

  /**
   * A message: "CIDR IPv6 is not valid.".
   *
   * @var string
   */
  public $ip6Value = "CIDR IPv6 is not valid. Single IP addresses must be in x.x.x.x/32 notation.";

  /**
   * A message: "CIDR IPv6 is empty".
   *
   * @var string
   */
  public $ip6IsEmpty = "CIDR IPv6 is empty.";

  /**
   * A message: "Group ID is empty".
   *
   * @var string
   */
  public $groupIdIsEmpty = "Group ID is empty.";

  /**
   * A message: "No security group found".
   *
   * @var string
   */
  public $noSecurityGroup = "No security group found.";

  /**
   * A message: "From Port is greater than To Port".
   *
   * @var string
   */
  public $toPortGreater = "From Port is greater than To Port.";

}
