<?php

namespace Drupal\k8s\Entity;

use Drupal\views\EntityViewsData;

/**
 * Provides the views data for the Config Map entity type.
 */
class K8sConfigMapViewsData extends EntityViewsData {

  /**
   * {@inheritdoc}
   */
  public function getViewsData() {
    $data = parent::getViewsData();

    $data['k8s_config_map']['config_map_bulk_form'] = [
      'title' => $this->t('Config Map operations bulk form'),
      'help' => $this->t('Add a form element that lets you run operations on multiple Config Maps.'),
      'field' => [
        'id' => 'config_map_bulk_form',
      ],
    ];

    // Additional information for Views integration, such as table joins, can be
    // put here.
    $data['k8s_config_map']['table']['base']['access query tag'] = 'k8s_entity_views_access_with_namespace';

    return $data;
  }

}
