<?php

namespace Drupal\k8s\Entity;

use Drupal\cloud\Entity\CloudViewBuilder;

/**
 * Provides the cron job view builders.
 */
class K8sCronJobViewBuilder extends CloudViewBuilder {

  /**
   * {@inheritdoc}
   */
  protected function getFieldsetDefs() {
    return [
      [
        'name' => 'cron_job',
        'title' => t('Cron Job'),
        'open' => TRUE,
        'fields' => [
          'name',
          'namespace',
          'schedule',
          'active',
          'suspend',
          'last_schedule_time',
          'concurrency_policy',
          'created',
          'labels',
          'annotations',
        ],
      ],
      [
        'name' => 'cron_job_detail',
        'title' => t('Detail'),
        'open' => FALSE,
        'fields' => [
          'detail',
        ],
      ],
      [
        'name' => 'others',
        'title' => t('Others'),
        'open' => FALSE,
        'fields' => [
          'cloud_context',
          'uid',
        ],
      ],
    ];
  }

}
