<?php

namespace Drupal\k8s\Entity;

use Drupal\cloud\Entity\CloudViewBuilder;

/**
 * Provides the deployment view builders.
 */
class K8sDeploymentViewBuilder extends CloudViewBuilder {

  /**
   * {@inheritdoc}
   */
  protected function getFieldsetDefs() {
    return [
      [
        'name' => 'deployment',
        'title' => t('Deployment'),
        'open' => TRUE,
        'fields' => [
          'name',
          'namespace',
          'strategy',
          'min_ready_seconds',
          'revision_history_limit',
          'created',
          'labels',
          'annotations',
        ],
      ],
      [
        'name' => 'status',
        'title' => t('Status'),
        'open' => TRUE,
        'fields' => [
          'available_replicas',
          'collision_count',
          'observed_generation',
          'ready_replicas',
          'replicas',
          'unavailable_replicas',
          'updated_replicas',
        ],
      ],
      [
        'name' => 'deployment_detail',
        'title' => t('Detail'),
        'open' => FALSE,
        'fields' => [
          'detail',
          'creation_yaml',
        ],
      ],
      [
        'name' => 'others',
        'title' => t('Others'),
        'open' => FALSE,
        'fields' => [
          'cloud_context',
          'uid',
        ],
      ],
    ];
  }

}
