<?php

namespace Drupal\k8s\Entity;

use Drupal\cloud\Entity\CloudViewBuilder;

/**
 * Provides the job view builders.
 */
class K8sJobViewBuilder extends CloudViewBuilder {

  /**
   * {@inheritdoc}
   */
  protected function getFieldsetDefs() {
    return [
      [
        'name' => 'job',
        'title' => t('Job'),
        'open' => TRUE,
        'fields' => [
          'name',
          'namespace',
          'image',
          'completions',
          'parallelism',
          'created',
          'labels',
          'annotations',
        ],
      ],
      [
        'name' => 'pod_status',
        'title' => t('Pod Status'),
        'open' => TRUE,
        'fields' => [
          'active',
          'succeeded',
          'failed',
        ],
      ],
      [
        'name' => 'job_detail',
        'title' => t('Detail'),
        'open' => FALSE,
        'fields' => [
          'detail',
        ],
      ],
      [
        'name' => 'others',
        'title' => t('Others'),
        'open' => FALSE,
        'fields' => [
          'cloud_context',
          'uid',
        ],
      ],
    ];
  }

}
