<?php

namespace Drupal\k8s\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining a Network Policy entity.
 *
 * @ingroup k8s
 */
interface K8sNetworkPolicyInterface extends ContentEntityInterface, EntityOwnerInterface {

  /**
   * {@inheritdoc}
   */
  public function getCloudContext();

  /**
   * {@inheritdoc}
   */
  public function getName();

  /**
   * {@inheritdoc}
   */
  public function setName($name);

  /**
   * {@inheritdoc}
   */
  public function getNamespace();

  /**
   * {@inheritdoc}
   */
  public function setNamespace($namespace);

  /**
   * {@inheritdoc}
   */
  public function getLabels();

  /**
   * {@inheritdoc}
   */
  public function setLabels($labels);

  /**
   * {@inheritdoc}
   */
  public function getAnnotations();

  /**
   * {@inheritdoc}
   */
  public function setAnnotations($annotations);

  /**
   * {@inheritdoc}
   */
  public function getStatus();

  /**
   * {@inheritdoc}
   */
  public function setStatus($status);

  /**
   * {@inheritdoc}
   */
  public function getEgress();

  /**
   * {@inheritdoc}
   */
  public function setEgress($egress);

  /**
   * {@inheritdoc}
   */
  public function getIngress();

  /**
   * {@inheritdoc}
   */
  public function setIngress($ingress);

  /**
   * {@inheritdoc}
   */
  public function getPolicyTypes();

  /**
   * {@inheritdoc}
   */
  public function setPolicyTypes($policy_types);

  /**
   * {@inheritdoc}
   */
  public function getPodSelector();

  /**
   * {@inheritdoc}
   */
  public function setPodSelector($pod_selector);

  /**
   * {@inheritdoc}
   */
  public function getDetail();

  /**
   * {@inheritdoc}
   */
  public function setDetail($detail);

  /**
   * {@inheritdoc}
   */
  public function getCreationYaml();

  /**
   * {@inheritdoc}
   */
  public function setCreationYaml($creation_yaml);

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function changed();

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

}
