<?php

namespace Drupal\k8s\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining a Service entity.
 *
 * @ingroup k8s
 */
interface K8sServiceEntityInterface extends ContentEntityInterface, EntityOwnerInterface {

  /**
   * {@inheritdoc}
   */
  public function getCloudContext();

  /**
   * {@inheritdoc}
   */
  public function getName();

  /**
   * {@inheritdoc}
   */
  public function setName($name);

  /**
   * {@inheritdoc}
   */
  public function getNamespace();

  /**
   * {@inheritdoc}
   */
  public function setNamespace($namespace);

  /**
   * {@inheritdoc}
   */
  public function getLabels();

  /**
   * {@inheritdoc}
   */
  public function setLabels($labels);

  /**
   * {@inheritdoc}
   */
  public function getAnnotations();

  /**
   * {@inheritdoc}
   */
  public function setAnnotations($annotations);

  /**
   * {@inheritdoc}
   */
  public function getSelector();

  /**
   * {@inheritdoc}
   */
  public function setSelector($selector);

  /**
   * {@inheritdoc}
   */
  public function getSessionAffinity();

  /**
   * {@inheritdoc}
   */
  public function setSessionAffinity($session_affinity);

  /**
   * {@inheritdoc}
   */
  public function getClusterIp();

  /**
   * {@inheritdoc}
   */
  public function setClusterIp($cluster_ip);

  /**
   * {@inheritdoc}
   */
  public function getInternalEndpoints();

  /**
   * {@inheritdoc}
   */
  public function setInternalEndpoints($internal_endpoints);

  /**
   * {@inheritdoc}
   */
  public function getExternalEndpoints();

  /**
   * {@inheritdoc}
   */
  public function setExternalEndpoints($external_endpoints);

  /**
   * {@inheritdoc}
   */
  public function getDetail();

  /**
   * {@inheritdoc}
   */
  public function setDetail($detail);

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function changed();

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

}
