<?php

namespace Drupal\k8s\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'key_value_item' widget.
 *
 * @FieldWidget(
 *   id = "key_value_item",
 *   label = @Translation("K8s key value"),
 *   field_types = {
 *     "key_value"
 *   }
 * )
 */
class KeyValueItem extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $key = isset($items[$delta]->item_key) ? $items[$delta]->item_key : NULL;
    $value = isset($items[$delta]->item_value) ? $items[$delta]->item_value : NULL;

    $element['item_key'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Key'),
      '#size' => 60,
      '#default_value' => $key,
      '#maxlength' => 255,
      '#prefix' => '<div class="col-sm-6">',
      '#suffix' => '</div>',
    ];

    $element['item_value'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Value'),
      '#size' => 60,
      '#default_value' => $value,
      '#maxlength' => 255,
      '#prefix' => '<div class="col-sm-6">',
      '#suffix' => '</div>',
    ];

    return $element;
  }

}
