<?php

namespace Drupal\k8s\Service\K8sClientExtension\Collections;

use Maclof\Kubernetes\Collections\Collection;

use Drupal\k8s\Service\K8sClientExtension\Models\K8sLimitRange;

/**
 * K8s limit ranges collection.
 */
class K8sLimitRangeCollection extends Collection {

  /**
   * The constructor.
   *
   * @param array $items
   *   The items.
   */
  public function __construct(array $items) {
    parent::__construct($this->getLimitRanges($items));
  }

  /**
   * Get an array of limit ranges.
   *
   * @param array $items
   *   The items.
   *
   * @return array
   *   The array of limit ranges.
   */
  protected function getLimitRanges(array $items) {
    foreach ($items as &$item) {
      if ($item instanceof K8sLimitRange) {
        continue;
      }

      $item = new K8sLimitRange($item);
    }

    return $items;
  }

}
