<?php

namespace Drupal\openstack\Entity;

use Drupal\aws_cloud\Entity\Ec2\AwsCloudViewBuilder;

/**
 * Provides the instance view builders.
 */
class InstanceViewBuilder extends AwsCloudViewBuilder {

  /**
   * {@inheritdoc}
   */
  protected function getfieldsetDefs() {
    return [
      [
        'name' => 'instance',
        'title' => t('Instance'),
        'open' => TRUE,
        'fields' => [
          'instance_id',
          'name',
          'instance_type',
          'instance_state',
          'image_name',
          'reservation',
          'account_id',
          'launch_time',
        ],
      ],
      [
        'name' => 'network',
        'title' => t('Network'),
        'open' => TRUE,
        'fields' => [
          'private_ips',
          'public_dns',
          'private_dns',
          'security_groups',
          'key_pair_name',
          'availability_zone',
        ],
      ],
      [
        'name' => 'storage',
        'title' => t('Storage'),
        'open' => TRUE,
        'fields' => [
          'root_device_type',
          'root_device',
        ],
      ],
      [
        'name' => 'options',
        'title' => t('Options'),
        'open' => TRUE,
        'fields' => [
          'ami_launch_index',
        ],
      ],
      [
        'name' => 'others',
        'title' => t('Others'),
        'open' => FALSE,
        'fields' => [
          'cloud_context',
          'uid',
        ],
      ],
    ];
  }

}
