<?php

namespace Drupal\openstack\Plugin\Derivative;

use Drupal\aws_cloud\Plugin\Derivative\AwsCloudMenuLinks;

/**
 * OpenStack menu link generation.
 */
class OpenStackCloudMenuLinks extends AwsCloudMenuLinks {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $entities = $this->cloudConfigPluginManager->loadConfigEntities('openstack');

    foreach ($entities as $entity) {
      /* @var \Drupal\cloud\Entity\CloudConfig $entity */
      $id = $entity->id() . '.local_tasks.' . $entity->getCloudContext();
      $this->derivatives[$id] = $base_plugin_definition;
      $this->derivatives[$id]['title'] = $entity->label();
      $this->derivatives[$id]['route_name'] = 'view.openstack_cloud_instance.list';
      $this->derivatives[$id]['base_route'] = 'cloud.service_providers.menu';
      $this->derivatives[$id]['parent'] = 'cloud.service_providers.menu';
      $this->derivatives[$id]['route_parameters'] = ['cloud_context' => $entity->getCloudContext()];
    }

    return $this->derivatives;
  }

}
